#ifndef D3DRAW_H
#define D3DRAW_H
#include "config.h"
#include "3d.h"
#include "3dmodel.h"


#define WIN_WIDTH 640
#define WIN_HEIGHT 480

#define SENSOR_LT_X 32*15+8
#define SENSOR_LT_Y 32*6
#define SENSOR_XSIZE 128
#define SENSOR_YSIZE 128
#define SENSOR_RB_X (SENSOR_LT_X + SENSOR_XSIZE)
#define SENSOR_RB_Y (SENSOR_LT_Y + SENSOR_YSIZE)
#define SENSOR_X0  (SENSOR_LT_X + SENSOR_XSIZE/2 + 180) 
#define SENSOR_Y0  (SENSOR_LT_Y + SENSOR_YSIZE/2 - 150)
#define GROUND_HEIGHT 500


void draw_3dline(point3d_t st3d, point3d_t en3d);
void draw_3dline_sensor(point3d_t st3d, point3d_t en3d, int xa, int ya);
void draw_shadowline(point3d_t st3d, point3d_t en3d);
void draw_shadow(model3d_t *model, int motion, point3d_t pos);
void draw_model(model3d_t *model, int motion, point3d_t pos);
void draw_hitbox(model3d_t *model, point3d_t pos);
void animate_sensor_model(model3d_t *model);
void draw_sensor_model(model3d_t *model);
void draw_explosion(model3d_t *model, int motion, int emotion, point3d_t pos);
void create_explosion(model3d_t *model);

#endif







