#include "3dmodel.h"

model3d_t myship_model = {
  ct_myship,
  {{
	{  0,  0, 32},   // 0 
	
	{  0,-16,-32},   // 1-3 
	{-16,  0,-32},
	{ 16,  0,-32},
	
	{ -8,  0,  0},   // 4-6 
	{-48,  0,-16},
	{-48,  0,-40},
	
	{  8,  0,  0},   // 7-9 
	{ 48,  0,-16},
	{ 48,  0,-40},

	{  0,-12,-16},   // 10-12 
	{  0,-32,-30},
	{  0,-32,-36},
  }},
  {{{{0, 0, 0}}}},
  {
	{ 0, 1},
	{ 0, 2},
	{ 0, 3},
	
	{ 1, 2},
	{ 1, 3},
	{ 2, 3},
	
	{ 4, 5},
	{ 5, 6},
	{ 6, 2},
	
	{ 7, 8},
	{ 8, 9},
	{ 9, 3},

	{10,11},
	{11,12},
	{12, 1},
  },
  {
	{ 0, 4},
	{ 4, 5},
	{ 5, 6},
	{ 6, 2},
	{ 2, 3},
	
	{ 0, 7},
	{ 7, 8},
	{ 8, 9},
	{ 9, 3},
  },
  {{0, 0}},
  13, 0, 15, 9, 5,
  0, 0, 3,   // ⡼롼ס
  24, 24, // xsize, zsize 
  0, 0,   // sensor_xoffset, sensor_yoffset;
};

model3d_t enemyship_model[et_end];

model3d_t scout_model = {
  ct_enemyship,
  {{
	{  0,  0,-32},   // 0 
	
	{  0,-16, 32},   // 1-3 
	{-16,  0, 32},
	{ 16,  0, 32},
	
	{-48,  0, 40},   // 4 
	
	{ 48,  0, 40},   // 5 
  }},
  {{{{0, 0, 0}}}},
  {
	{ 0, 1},
	{ 0, 2},
	{ 0, 3},
	
	{ 1, 2},
	{ 1, 3},
	{ 2, 3},
	
	{ 0, 4},
	{ 4, 2},
	 
	{ 0, 5},
	{ 5, 3},
  },
  {
	{ 0, 4},
	{ 4, 2},
	{ 2, 3},
	{ 3, 5},
	{ 5, 0},
  },
  {{0, 0}},
  6, 0, 10, 5, 3,
  0, 0, 1,   // ⡼롼ס
  32, 32, // xsize, zsize 
  0, 0,   // sensor_xoffset, sensor_yoffset;
};

model3d_t wall_model = {
  ct_enemyship,
  {{
	{-64,  32, 0},
	{-64, -32, 0},
	{ 64, -32, 0},
	{ 64,  32, 0},
  }},
  {{{{0, 0, 0}}}},
  {
	{ 0, 1},
	{ 1, 2},
	{ 2, 3},
	{ 3, 0},
  },
  {
	{ 0, 1},
	{ 1, 2},
	{ 2, 3},
	{ 3, 0},
  },
  {{0, 0}},
  4, 0, 4, 4, 0,
  0, 11, 12,   // ⡼롼ס
  64, 32, // xsize, zsize 
  0, 0,   // sensor_xoffset, sensor_yoffset;
};

model3d_t drone_model = {
  ct_enemyship,
  {{
	{  0, -32,  0},
	{-28,   0,-16},
	{ 28,   0,-16},
	{  0,   0, 32},
  }},
  {{{{0, 0, 0}}}},
  {
	{ 0, 1},
	{ 0, 2},
	{ 0, 3},
	{ 1, 2},
	{ 2, 3},
	{ 3, 1},
  },
  {
	{ 1, 2},
	{ 2, 3},
	{ 3, 1},
  },
  {{0, 0}},
  4, 0, 6, 3, 0,
  0, 11, 12,   // ⡼롼ס
  12, 12, // xsize, zsize 
  0, 0,   // sensor_xoffset, sensor_yoffset;
};


model3d_t fighter_model = {
  ct_enemyship,
  {{
	{  0,  0,-24},   // 0 

	{  8,  0, 24},   // 1-3 
	{ -8,  0, 24},
	{  0,-12, 24},

	{-48,  0, 30},   // 4-6 
	{-48,  0, 20},
	{ -4,  0,  0},

	{ 48,  0, 30},   // 7-9 
	{ 48,  0, 20},
	{  4,  0,  0},
  }},
  {{{{0, 0, 0}}}},
  {
	{ 0, 1},
	{ 0, 2},
	{ 0, 3},
	{ 1, 2},
	{ 2, 3},
	{ 3, 1},

    { 2, 4},
    { 4, 5},
    { 5, 6},

    { 1, 7},
    { 7, 8},
    { 8, 9},
  },
  {
	{ 0, 6},
	{ 0, 9},
	{ 1, 2},

    { 2, 4},
    { 4, 5},
    { 5, 6},

    { 1, 7},
    { 7, 8},
    { 8, 9},
  },
  {{0, 0}},
  10, 0, 12, 9, 0,
  0, 0, 11, // ⡼롼ס (FIGHTERϥ󥵾Ǥϥ˥᡼󤷤ʤ)
  12, 12, // xsize, zsize 
  0, 0,   // sensor_xoffset, sensor_yoffset;
};


model3d_t copter_model = {
  ct_enemyship,
  {{
	{  0,  0, 32},   // 0 
	
	{  0,-24,  0},   // 1-3 
	{-24,  0, -8},
	{ 24,  0, -8},

	{  0,-32,  0},   // 4 

	{  0,-32, 32},   // 5-6  
	{  0,-32,-32},
  }},
  {{{{0, 0, 0}}}},
  {
	{ 0, 1},
	{ 0, 2},
	{ 0, 3},
	{ 1, 2},
	{ 2, 3},
	{ 3, 1},

	{ 1, 4},
	{ 5, 6},
  },
  {
	{ 0, 2},
	{ 2, 3},
	{ 3, 0},
  },
  {{0, 0}},
  7, 0, 8, 3, 3,
  0, 5, 6,   // ⡼롼ס
  16, 16, // xsize, zsize 
  0, 0,   // sensor_xoffset, sensor_yoffset;
};


model3d_t lancer_model = {
  ct_enemyship,
  {{
	{  0,  0,-32},   // 0 

	{ -8, -8, 32},   // 1-4 
	{  8, -8, 32},
	{  8,  8, 32},
	{ -8,  8, 32},
  }},
  {{{{0, 0, 0}}}},
  {
	{ 0, 1},
	{ 0, 2},
	{ 0, 3},
	{ 0, 4},
	{ 1, 2},
	{ 2, 3},
	{ 3, 4},
	{ 4, 1},
  },
  {
	{ 0, 3},
	{ 3, 4},
	{ 4, 0},
  },
  {{0, 0}},
  5, 0, 8, 3, 2,
  0, 0, 1,   // ⡼롼ס
  8, 32, // xsize, zsize 
  0, 0,   // sensor_xoffset, sensor_yoffset;
};


model3d_t walker_model = {
  ct_enemyship,
  {{
	{-32,-180,  8},   // 0-7 Ƭ
	{ 32,-180,  8},
	{ 32,-180,- 8},
	{-32,-180,- 8},
	{-32,-140,  8},
	{ 32,-120,  8},
	{ 32,-120,- 8},
	{-32,-140,- 8},

	{  0,-130,- 4},  // 8-10 ­
	{ 40, -60,- 4},
	{  0,   0,- 4},

	{  0,-130,  4},  // 11-13 ­
	{ 40, -60,- 4},
	{  0,   0,  4},
  }},
  {{{{0, 0, 0}}}},
  {
	{ 0, 1},
	{ 1, 2},
	{ 2, 3},
	{ 3, 0},
	{ 4, 5},
	{ 5, 6},
	{ 6, 7},
	{ 7, 4},
	{ 0, 4},
	{ 1, 5},
	{ 2, 6},
	{ 3, 7},

	{ 8, 9},
	{ 9,10},

	{11,12},
	{12,13},
  },
  {
	{ 4, 5},
	{ 5, 6},
	{ 6, 7},
	{ 7, 4},
  },
  {{0, 0}},
  14, 0, 16, 4, 4,
  0, 15, 32,   // ⡼롼ס(16ѥ)
  32, 32, // xsize, zsize 
  0, 32,   // sensor_xoffset, sensor_yoffset;
};


model3d_t turret_model = {
  ct_enemyship,
  {{
	{-48,   0,-16},   // 0-3 ´
	{ 48,   0,-16},   
	{ 48,   0, 16},   
	{-48,   0, 16},   
	{-32,-140, -4},   // 4-7 Ƭĺ
	{ 32,-140, -4},   
	{ 32,-140,  8},   
	{-32,-140,  8},
	{-32,-180, -4},   // 8-11 ˤƬĺ
	{ 32,-180, -4},   
	{ 32,-180,  8},   
	{-32,-180,  8},

	{-12,-160, -4},  // 12-15 ˤ
	{  0,-172, -4},  
	{ 12,-160, -4},  
	{  0,-148, -4},  
    
  }},
  {{{{0, 0, 0}}}},
  {
	{ 0, 1},
	{ 1, 2},
	{ 2, 3},
	{ 3, 0},
	{ 4, 5},
	{ 5, 6},
	{ 6, 7},
	{ 7, 4},

	{ 0, 4},
	{ 1, 5},
	{ 2, 6},
	{ 3, 7},

    { 8, 9},
    { 9,10},
    {10,11},
    {11, 8},
    { 4, 8},
    { 5, 9},
    { 6,10},
    { 7,11},

    {12,13},
    {13,14},
    {14,15},
    {15,12},
  },
  {{0, 0}}, // ƤϤĤʤ
  {{0, 0}},
  16, 0, 24, 0, 0,
  0, 5, 6,   // ⡼롼ס
  32, 32, // xsize, zsize 
  0, 32,   // sensor_xoffset, sensor_yoffset;
};


model3d_t fortress_model = {
  ct_enemyship,
  {{
	{   0,  0, 384},   // 0-2 
	{ 333,  0,-192},
	{-333,  0,-192},

	{   0,  0,-384},   // 3-5 
	{ 333,  0, 192},
	{-333,  0, 192},

	{ 111,  0,-192},   // 6-11 
	{-111,  0,-192},
	{-192,  0,   0},
	{-111,  0, 192},
	{ 111,  0, 192},
	{ 192,  0,   0},

	{   0,-128,  0},  // 12


  }},
  {{{{0, 0, 0}}}},
  {
	{ 0, 1},
	{ 1, 2},
	{ 2, 0},

	{ 3, 4},
	{ 4, 5},
	{ 5, 3},

	{ 6,12},
	{ 7,12},
	{ 8,12},
	{ 9,12},
	{10,12},
	{11,12},
  },
  {
	{ 0, 9},
	{ 9, 5},
	{ 5, 8},
	{ 8, 2},
	{ 2, 7},
	{ 7, 3},
	{ 3, 6},
	{ 6, 1},
	{ 1,11},
	{11, 4},
	{ 4,10},
	{10, 0},
  },
  {{0, 0}},
  13, 0, 12, 12, 0,
  0, 29, 30,   // ⡼롼ס
  32, 32, // xsize, zsize 
  0, 0,   // sensor_xoffset, sensor_yoffset;
};

model3d_t bomber_model = {
  ct_enemyship,
  {{
	{    0,    0,    50},   // 0-3 ƹ
	{  -40,  -30,    60},   
	{   40,  -30,    60},
	{    0,    0,   -60},

    { -280,  -30,    40},  // 4-5 
    {  -15,  -10,   -20},

    {  280,  -30,    40},  // 6-7 
    {   15,  -10,   -20},

    /*
    {    0,  -30,   -60},  // 8-10 ľ
	{    0,  -30,   -50},
	{    0,   -5,   -40},
	{    0,    0,     0}, // 11 dummy
    */
    /*    
    */
    {  100,  -30,    55},  // 8-9ץڥ鼴()
    {  100,  -30,    65},
    { -100,  -30,    55},  // 10-11ץڥ鼴()
    { -100,  -30,    65},
    {  220,  -30,    45},  // 12-13ץڥ鼴()
    {  220,  -30,    55},
    { -220,  -30,    45},  // 14-15ץڥ鼴()
    { -220,  -30,    55},

    {  50,   -30,    65}, // 16-19 ץڥ
    { 150,   -30,    65},
    { 100,    20,    65},
    { 100,   -80,    65},

    { -50,   -30,    65}, // 20-23 ץڥ
    {-150,   -30,    65},
    {-100,    20,    65},
    {-100,   -80,    65},

    { 170,   -30,    55}, // 24-27 ץڥ
    { 270,   -30,    55},
    { 220,    20,    55},
    { 220,   -80,    55},

    {-170,   -30,    55}, // 28-31 ץڥ
    {-270,   -30,    55},
    {-220,    20,    55},
    {-220,   -80,    55},

  }},
  {{{{0, 0, 0}}}},
  {
	{ 0, 1},          // 0-5
	{ 0, 2},
	{ 1, 2},
    { 0, 3},
	{ 1, 3},
	{ 2, 3},

    { 1, 4},
    { 4, 5},

    { 2, 6},
    { 6, 7},

    {16,17},
    {18,19},
    {20,21},
    {22,23},
    {24,25},
    {26,27},
    {28,29},
    {30,31},
    /*
    { 3, 8},
    { 8, 9},
    { 9,10},
    {10, 3},
    */
  },
  {
	{ 1, 2},
	{ 1, 4},
	{ 4, 5},
	{ 5, 3},
	{ 2, 6},
	{ 6, 7},
	{ 7, 3},
  },
  {{0, 0}},
  32, 0, 18, 7, 0,
  0, 17, 18, // ⡼롼ס
  32, 16, // xsize, zsize 
  0, 0,   // sensor_xoffset, sensor_yoffset;
};

model3d_t wyvern_model = {
  ct_enemyship,
  {{
	{    0,    0,    50},   // 0-5 ƹ
	{  -40,  -30,    60},   
	{   40,  -30,    60},

	{    0,    0,    10},
	{  -20,  -10,    10},   
	{   20,  -10,    10},

	{    0,   60,  -120},   // 6 
    

	{ -160,  -40,    60},   // 7-9
	{ -160,  -40,    10},
	{ -240,  -30,    20},

	{  160,  -40,    60},   // 10-12
	{  160,  -40,    10},
	{  240,  -30,    20},

	{  -20,  -70,    60},  // 13-15 Ƭ
	{   20,  -70,    60},
	{    0,   40,   120},
  }},
  {{{{0, 0, 0}}}},
  {
	{ 0, 1}, 
	{ 0, 2},
	{ 1, 2},
    { 3, 4},
    { 3, 5},
    { 4, 5},
    { 0, 3},
	{ 1, 4},
	{ 2, 5},
	{ 3, 6},
	{ 4, 6},
	{ 5, 6},

	{ 1, 7},
	{ 7, 8},
	{ 8, 4},
	{ 7, 9},
	{ 9, 8},

  	{ 2,10},
	{10,11},
	{11, 5},
	{10,12},
	{12,11},

	{13, 1},
	{14, 2},
	{15, 0},
    {13,14},
    {13,15},
    {14,15},
},
  {
	{ 1, 7},
	{ 7, 9},
	{ 9, 8},
	{ 8, 4},
	{ 4, 6},
	{ 6, 5},

	{ 5,11},
	{11,12},
	{12,10},
	{10, 2},
	{ 2,14},
	{14,15},
	{15,13},
	{13, 1},
  },
  {{0, 0}},
 15, 0, 29, 14, 0,
  0, 23, 24, // ⡼롼ס
  32, 64, // xsize, zsize 
  0, 0,   // sensor_xoffset, sensor_yoffset;
};

model3d_t byte_model = {
  ct_enemyship,
  {{
	{  20,  30,   20},
	{ -20,  30,   20},
	{  15, -30,   10},
	{ -15, -30,   10},
	{  15, -30,   20},
	{ -15, -30,   20},
  }},
  {{{{0, 0, 0}}}},
  {
	{ 0, 1},
	{ 2, 3},
	{ 4, 5},

	{ 0, 2},
	{ 1, 3},
	{ 0, 4},
	{ 1, 5},

    { 2, 4},
    { 3, 5},
  },
  {
	{ 0, 1},
	{ 2, 3},
	{ 0, 2},
	{ 1, 3},
  },
  {{0, 0}},
  6, 0, 9, 4, 0,
  8, 8, 9, // ⡼롼ס
  32, 24, // xsize, zsize 
  0, 0,   // sensor_xoffset, sensor_yoffset;
};

model3d_t gunroid_model = {
  ct_enemyship,
  {{
	{   0, -80,   0},   // 0-3 Ƭ
	{ -20, -50,  -5},
	{  20, -50,  -5},
	{   0, -50,   5},

	{   0, -70,  -5},  // 4-6 ƥ
	{ -20, -80,  -5},
	{  20, -80,  -5},

	{ -20, -40,  -5},  // 7-14 ƹ
	{  20, -40,  -5},
	{  20, -40,   5},
	{ -20, -40,   5},
	{ -10,   0,   0},
	{  10,   0,   0},
    {0, 0, 0},
    {0, 0, 0},
    
	{ -10,   0,    0},  // 15-17 ­
	{ -20,  60,    0},
	{  -5,  60,    0},

	{  10,   0,    0},  // 18-20 ­
	{  20,  60,    0},
	{   5,  60,    0},

	{   0, -30,   -10},  // 21-24 
	{  30, -30,   -10},
	{  30,  20,   -10},
	{   0,  20,   -10},

	{ -25, -10,  -30}, // 25-29
	{ -25, -10,    0},
	{ -25, -20,    0},
	{ -30, -15,    0},
    { -20, -35,    0},
    
  }},
  {{{{0, 0, 0}}}},
  {
	{ 0, 1},
	{ 0, 2},
	{ 0, 3},
	{ 1, 2},
	{ 2, 3},
	{ 3, 1},

	{ 4, 5},
	{ 4, 6},

	{ 7, 8},
	{ 8, 9},
	{ 9,10},
	{10, 7},

	{11,12},

	{ 7,11},
	{ 8,12},
	{ 9,12},
	{10,11},

	{15,16},
	{15,17},
	{16,17},

	{18,19},
	{18,20},
	{19,20},
    
	{21,22},
	{22,23},
	{23,24},
	{24,21},

	{25,26},
	{25,27},
	{25,28},
    {28,29},
  },
  {
      /*
	{ 1, 2},
	{ 2, 3},
	{ 3, 1},
      */
	{ 7, 8},
	{ 8, 9},
	{ 9,10},
	{10, 7},

	{ 23, 24},

	{25,26},
	{25,27},
	{25,28},
    {28,29},

  },
  {{0, 0}},
  28, 0, 31, 9, 0,
  0, 0, 1, // ⡼롼ס
  32, 32, // xsize, zsize 
  0, 0,   // sensor_xoffset, sensor_yoffset;
};
model3d_t gunroid_model_old = {
  ct_enemyship,
  {{
	{   0, -80,   0},   // 0-3 Ƭ
	{ -20, -50,  -5},
	{  20, -50,  -5},
	{   0, -50,   5},

	{   0, -70,  -5},  // 4-6 ƥ
	{ -20, -80,  -5},
	{  20, -80,  -5},

	{ -20, -40,  -5},  // 7-14 ƹ
	{  20, -40,  -5},
	{  20, -40,   5},
	{ -20, -40,   5},
	{ -15,   0,  -5},
	{  15,   0,  -5},
	{  15,   0,   5},
	{ -15,   0,   5},
    
	{ -10,   0,    0},  // 15-17 ­
	{ -15,  20,   -5},
	{ -20,  60,    0},

	{  10,   0,    0},  // 18-20 ­
	{  15,  20,   -5},
	{  20,  60,    0},

	{   0, -30,   -10},  // 21-24 
	{  30, -30,   -10},
	{  30,  20,   -10},
	{   0,  20,   -10},

	{ -25, -10,  -30}, // 25-28
	{ -25, -10,    0},
	{ -25, -20,    0},
	{ -30, -15,    0},
    { -20, -35,    0},
    
  }},
  {{{{0, 0, 0}}}},
  {
	{ 0, 1},
	{ 0, 2},
	{ 0, 3},
	{ 1, 2},
	{ 2, 3},
	{ 3, 1},

	{ 4, 5},
	{ 4, 6},

	{ 7, 8},
	{ 8, 9},
	{ 9,10},
	{10, 7},

	{11,12},
	{12,13},
	{13,14},
	{14,11},

	{ 7,11},
	{ 8,12},
	{ 9,13},
	{10,14},

	{15,16},
	{16,17},

	{18,19},
	{19,20},
    
	{21,22},
	{22,23},
	{23,24},
	{24,21},

	{25,26},
	{25,27},
	{25,28},
    {28,29},
  },
  {
      /*
	{ 1, 2},
	{ 2, 3},
	{ 3, 1},
      */
	{ 7, 8},
	{ 8, 9},
	{ 9,10},
	{10, 7},

	{ 23, 24},

	{25,26},
	{25,27},
	{25,28},
    {28,29},

  },
  {{0, 0}},
  28, 0, 32, 9, 0,
  0, 0, 1, // ⡼롼ס
  32, 32, // xsize, zsize 
  0, 0,   // sensor_xoffset, sensor_yoffset;
};

model3d_t dragon_head_model = {
  ct_enemyship,
  {{
    { -50,    0,   0},  // 0-3 Ƭ
	{   0,    0,  20},
	{   0,    0, -20},
    {   0,  -20,   0},

	{ -40,    0,   0},   // 4 
  }},
  {{{{0, 0, 0}}}},
  {
	{ 0, 1},
	{ 1, 2},
	{ 2, 0},
	{ 0, 3},
	{ 1, 3},
	{ 2, 3},

	{ 1, 4},
	{ 2, 4},
  },
  {
	{ 0, 1},
	{ 1, 2},
	{ 2, 0},
  },
  {{0, 0}},
  5, 0, 8, 3, 0,
  0, 31, 32,  // ⡼롼
          // ºݤΥ⡼롼פmove_xxx椹뤬
          // sensorΥ˥᡼ȯѥκϤͤѤ
  32, 32, // xsize, zsize 
  0, 0,   // sensor_xoffset, sensor_yoffset;
};


model3d_t dragon_model = {
  ct_enemyship,
  {{

    {   0, -90,   0},  // 0-4 ƹ
	{   0, -50, -20},
	{  50, -50,  20},
	{ -50, -50,  20},
	{   0, -40,   0},

    { 150, -90,  40},  // 5-6 
    { 120, -20,  10},

    {-150, -90,  40},  // 7-8 
    {-120, -20,  10},

    { -50, -10,  10},  // 9-11 ­
    { -30, -10,  10},
    { -40, -10, -10},

    {  50, -10,  10},  // 12-14 ­
    {  30, -10,  10},
    {  40, -10, -10},

    {   0, -10, 150},  // 15 




    /*

    {   0, -90,   0},  // 0-3 ƹ

	{  50, -50,  20},
	{ -50, -50,  20},
	{   0, -30, -20},

	{  30, -30,  10},
	{ -30, -30,  10},
	{   0, -30, -10},

	{   0, -10, 100},






 

    {   0,   0, 120},  // 6 

	{ 160, -80,  30},  // 7-9 
	{ 240, -40,  20},
	{ 160, -60,  25},

	{-160, -80,  30},  // 10-12
	{-240, -40,  20},
	{-160, -60,  25},

    { -60,   0, -20}, // 13-15
    {   0, -20, -25},
	{  50, -20,   5},

    {  60,   0, -20}, // 16-18
    {   0, -20, -25},
	{ -50, -20,   5},
    */

  }},
  {{{{0, 0, 0}}}},
  {
	{ 0, 1},
	{ 0, 2},
	{ 0, 3},

	{ 1, 2},
	{ 2, 3},
	{ 3, 1},

	{ 4, 1},
	{ 4, 2},
	{ 4, 3},

	{ 2, 5},
	{ 5, 6},
	{ 6, 2},
	{ 3, 7},
	{ 7, 8},
	{ 8, 3},

	{ 9,10},
	{10,11},
	{11, 9},
	{ 4, 9},
	{ 4,10},
	{ 4,11},

	{12,13},
	{13,14},
	{14,12},
	{ 4,12},
	{ 4,13},
	{ 4,14},

	{ 2,15},
	{ 3,15},
	{ 4,15},

    /*
	{ 4, 5},
	{ 5, 6},
	{ 6, 4},

	{ 7, 4},
	{ 7, 5},
	{ 7, 6},


	{ 0, 1},
	{ 0, 2},
	{ 0, 3},
	{ 4, 1},
	{ 4, 2},
	{ 4, 3},

	{ 1, 2},
	{ 2, 3},
	{ 3, 1},


    { 4, 5},
	{ 5, 3},
	{ 0, 3},
	{ 1, 4},
	{ 2, 5},

	{ 3, 6},
	{ 4, 6},
	{ 5, 6},

	{ 1, 7},
	{ 7, 8},
	{ 8, 9},
	{ 9, 4},
    
	{ 2,10},
	{10,11},
	{11,12},
	{12, 5},
    
	{13, 3},
	{13,14},
	{13,15},

	{16, 3},
	{16,17},
	{16,18},
    */

  },
  {
	{ 1, 2},
	{ 3, 1},
	{ 2, 15},
	{ 3, 15},

	{ 2, 5},
	{ 5, 6},
	{ 6, 2},
	{ 3, 7},
	{ 7, 8},
	{ 8, 3},

	{ 9, 10},
	{10, 11},
	{11,  9},

	{12, 13},
	{13, 14},
	{14, 12},

  },
  {{0, 0}},
 16, 0, 30, 16, 0,
  0, 31, 32,  // ⡼롼
          // ºݤΥ⡼롼פmove_xxx椹뤬
          // sensorΥ˥᡼ȯѥκϤͤѤ
  0, 0, // xsize, zsize 
  0, 0,   // sensor_xoffset, sensor_yoffset;
};


model3d_t core_model = {
  ct_enemyship,
  {{

    {   0, -40,   0},  // 0-4 ƹ
	{   0, -10, -20},
	{  50, -10,  20},
	{ -50, -10,  20},
	{   0,   0,   0},
    {   0,  30, 150},  // 5 
	{   0,  10, -20},  // 6 




    //    { -30,   0,   0},
    //    {  30,   0,   0},
    //    {   0,  52,   0},


    /*
    {   0, -90,   0},  // 0-4 ƹ
	{   0, -50, -20},
	{  50, -50,  20},
	{ -50, -50,  20},

	{   0, -40,   0},
	{   0, -50, -20},
	{  50, -50,  20},
	{ -50, -50,  20},
    */
  }},
  {{{{0, 0, 0}}}},
  {
	{ 0, 1},
	{ 0, 2},
	{ 0, 3},

	{ 1, 2},
	{ 2, 3},
	{ 3, 1},

	{ 4, 6},
	{ 4, 2},
	{ 4, 3},

	{ 2, 5},
	{ 3, 5},
	{ 4, 5},

	{ 6, 2},
	{ 2, 3},
	{ 3, 6},

      /*
	{ 0, 1},
	{ 0, 2},
	{ 0, 3},

	{ 1, 2},
	{ 2, 3},
	{ 3, 1},

	{ 4, 5},
	{ 4, 6},
	{ 4, 7},
	{ 5, 6},
	{ 6, 7},
	{ 7, 5},
      */
  },
  {
	{ 1, 3},
	{ 1, 2},
	{ 2, 5},
	{ 3, 5},
  },
  {{0, 0}},
 7, 0, 15, 4, 0,
  0, 31, 32,  // ⡼롼
          // ºݤΥ⡼롼פmove_xxx椹뤬
          // sensorΥ˥᡼ȯѥκϤͤѤ
  32, 32, // xsize, zsize 
  0, 0,   // sensor_xoffset, sensor_yoffset;
};
/*
model3d_t dragon_model = {
  ct_enemyship,
  {{
    {   0, -80, -30},  // 0-5 ƹ
	{ 100, -80,  30},
	{-100, -80,  30},
	{   0, -10, -20},
	{  60, -40,  20},
	{ -60, -40,  20},

	{   0,   0, 120},  // 6 

	{ 160, -80,  30},  // 7-9 
	{ 240, -40,  20},
	{ 160, -60,  25},

	{-160, -80,  30},  // 10-12
	{-240, -40,  20},
	{-160, -60,  25},

    { -60,   0, -20}, // 13-15
    {   0, -20, -25},
	{  50, -20,   5},

    {  60,   0, -20}, // 16-18
    {   0, -20, -25},
	{ -50, -20,   5},


  }},
  {{{{0, 0, 0}}}},
  {
	{ 0, 1},
	{ 1, 2},
	{ 2, 0},
	{ 3, 4},
	{ 4, 5},
	{ 5, 3},
	{ 0, 3},
	{ 1, 4},
	{ 2, 5},

	{ 3, 6},
	{ 4, 6},
	{ 5, 6},

	{ 1, 7},
	{ 7, 8},
	{ 8, 9},
	{ 9, 4},
    
	{ 2,10},
	{10,11},
	{11,12},
	{12, 5},
    
	{13, 3},
	{13,14},
	{13,15},

	{16, 3},
	{16,17},
	{16,18},


  },
  {
	{ 4, 6},
	{ 5, 6},
	{ 4, 0},
	{ 5, 0},
  },
  {{0, 0}},
  19, 0, 20, 4, 0,
  0, 0,   // ⡼롼
          // ºݤΥ⡼롼פmove_xxx椹뤬
          // sensorΥ˥᡼ȯѥκϤͤѤ
  32, 32, // xsize, zsize 
  0, 0,   // sensor_xoffset, sensor_yoffset;
};
*/



/*
model3d_t enemy_model = {
  ,
  {{
	{   0,  0,   0},   // ĺɸ¤
  }},
  {{{{0, 0, 0}}}},
  {
	{ 0, 1},          // ǥ(³ĺֹ)
  },
  {
	{ 0, 1},          // Ƥ(³ĺֹ)
  },
  {{0, 0}},
  ĺĿ, 0, ǥդο, Ƥդο, 0,
  0, 0,   // ⡼롼
          // ºݤΥ⡼롼פmove_xxx椹뤬
          // sensorΥ˥᡼ȯѥκϤͤѤ
  32, 32, // xsize, zsize 
  0, 0,   // sensor_xoffset, sensor_yoffset;
};

*/
