#ifndef D3MODEL_H
#define D3MODEL_H
#include "config.h"
#include "3d.h"
#include "color.h"

#define MOTION_MAX 32
#define EMOTION_MAX 16
#define VERTEX_MAX 32
#define EVERTEX_MAX (VERTEX_MAX*2)
#define EDGE_MAX   32
#define SEDGE_MAX  16
#define EEDGE_MAX  (EDGE_MAX*2)

typedef struct {
  int st;
  int en;
} lineix_t; 

typedef struct {
    color_type_t color_type;
    //    int color;
    point3d_t vertex[MOTION_MAX][VERTEX_MAX];
    point3d_t evertex[MOTION_MAX][EMOTION_MAX][EVERTEX_MAX];
    lineix_t edge[EDGE_MAX];
    lineix_t sedge[SEDGE_MAX];
    lineix_t eedge[EEDGE_MAX];
    int vertex_num;
    int evertex_num;
    int edge_num;
    int sedge_num;
    int eedge_num;
    // 󥵡Υ⡼롼׳ϡλ֡⡼
    // ˱ƥ⡼Ȥʬ뤿ᡢ
    // ŨΥ⡼move_xxx()椹뤬
    // 󥵡Ϥϰǥ롼פ
    // ȯեȺ⡼ˤĤƺ뤿ᡢɬפˤʤ
    int motion_st, motion_en, motion_num;
    int xsize, zsize;    //Ƚѥ
    int sensor_xoffset, sensor_yoffset;  //ɽΥեå
} model3d_t;

typedef enum {
    et_start = 0,
    et_scout = 0,// Ƥ⤿˰ưĤ
    et_wall,     // žĤľʡƤϤ
    et_drone,    // ̤򤱤褦˰ư
    et_fighter,  // ľʤƤȯͤȿžѤ
    et_copter,   // ưĤġȤɤͤ餤Ƥȯ
    et_lancer,   // X礦褦˺˲®Ĥ
    et_walker,   // 2­
    et_turret,   // ˤ㡣Ƥȯ
    et_fortress, // ܥ:̾庸ˤäưĤƤ¿ȯ
    et_bomber,   // ץڥĤ緿
    et_byte,     // ͷˤ
    et_gunroid,  // Ʈ
    et_wyvern,   // Фͭε
    et_dragon,   // ¿Ƭε
    et_dragon_head, // ¿ƬεƬ
    et_core,     // ¿Ƭεʳ
    et_end,
    et_midboss,  // ܥ(ơϿ)
    et_boss,     // ܥ(ơϿ)
    et_reserve = 63  // ŨɲûachievementsθߴȤ褦
                     // 64ʬΰݤƤ
} enemytype_t;

extern model3d_t myship_model;
extern model3d_t enemyship_model[et_end];
extern model3d_t scout_model;
extern model3d_t wall_model;
extern model3d_t drone_model;
extern model3d_t fighter_model;
extern model3d_t copter_model;
extern model3d_t lancer_model;
extern model3d_t walker_model;
extern model3d_t turret_model;
extern model3d_t fortress_model;
extern model3d_t bomber_model;
extern model3d_t wyvern_model;
extern model3d_t byte_model;
extern model3d_t gunroid_model;
extern model3d_t dragon_head_model;
extern model3d_t dragon_model;
extern model3d_t core_model;

// etܥܥʤ鿿
// BYTElife 1λ
#define IsEnemyTypeBoss(et) ((et) >= et_fortress && (et) != et_byte)

#define IsEnemyBlockingBullet(es) ((es)->type == et_wall || \
                                   ((es)->type == et_byte && (es)->motion != 8) )


#endif
