#include <stdio.h>
#include <EzGraph.h>
#include "color.h"

rgb_t rgbs[] = {
  {  0,   0,  0},
  {  0,   0,255},
  {255,   0,  0},
  {255,   0,255},
  {  0, 255,  0},
  {  0, 255,255},
  {255, 255,  0},
  {255, 255,255},

  { 80,  80, 80},
  {  0,   0,180},
};

color_set_type_t color_set_type = cs_original;

int color_table[cs_end][ct_end] = {
    // default
    {COLOR_SHADOW_DEFAULT, COLOR_GROUND_DEFAULT, 0, 7, COLOR_GROUND_DEFAULT,
     5, 5, 4, 7,
     2, 7, 2,
     5, 7, 6,
     4, 6, 2, 6, 3},
    // ibm
    {COLOR_NO_DRAW, 7, 0, 7, 7,
     7, 7, 7, 7,
     7, 7, 7,
     7, 0, 7,
     7, 7, 7, 7, 3},
    // mac
    {COLOR_NO_DRAW, 0, 7, 0, 0,
     0, 0, 0, 0,
     0, 0, 0,
     0, 7, 0,
     0, 0, 0, 0, 3},
    // mz
    {COLOR_NO_DRAW, 4, 0, 4, 4,
     4, 4, 4, 4,
     4, 4, 4,
     4, 0, 4,
     4, 4, 4, 4, 3},
    // default
    {COLOR_SHADOW_DEFAULT, COLOR_GROUND_DEFAULT, 0, 7, COLOR_GROUND_DEFAULT,
     5, 5, 4, 7,
     2, 7, 2,
     COLOR_NO_DRAW, 7, 6,
     COLOR_NO_DRAW, 6, 2, 6, 3},
};

int set_color(color_type_t ct){
    rgb_t *rgb;
    int color;

    color = color_table[color_set_type][ct];
    //    printf("*** COLOR %d->%d *****\n", ct, color);
    if (color == COLOR_NO_DRAW) return 1;
    rgb = &rgbs[color];
    EzSetColorByRGB(rgb->r, rgb->g, rgb->b);
    return 0;
}

void set_color_set_type(color_set_type_t cs){
    color_set_type = cs;
}


