#include <stdio.h>
#include <EzGraph.h>
#include "config.h"
#include "motion.h"
#include "3dshoot.h"


void create_motion_myship(model3d_t *model){
  int i;

  for (i = 0 ; i < model->vertex_num ; i++){
	model->vertex[1][i] = model->vertex[0][i];
  }
  for (i = 0 ; i < model->vertex_num ; i++){
	model->vertex[0][i] = rot_xy(model->vertex[1][i], -30);
  }
  for (i = 0 ; i < model->vertex_num ; i++){
	model->vertex[2][i] = rot_xy(model->vertex[1][i], 30);
  }
}

void create_motion_wall(model3d_t *model){
    int motion, i;
    int d = 15;
    for (motion = 1 ; motion < 12 ; motion ++){
        //	printf("motion:%d d:%d\n", motion, d);
        for (i = 0 ; i < model->vertex_num ; i++){
            model->vertex[motion][i] = rot_zy(model->vertex[0][i], -d);
        }
        d += 15;
    }
}


void create_motion_drone(model3d_t *model){
  int motion, i;
  int d = 10;
  for (motion = 1 ; motion < 12 ; motion ++){
	for (i = 0 ; i < model->vertex_num ; i++){
	  model->vertex[motion][i] = rot_xz(model->vertex[0][i], d);
	}
	d += 10;
  }
}


void create_motion_fighter(model3d_t *model){
  int motion, i;
  int d = 15;
  for (motion = 1 ; motion < 12 ; motion ++){
      //	printf("motion:%d d:%d\n", motion, d);
	for (i = 0 ; i < model->vertex_num ; i++){
	  model->vertex[motion][i] = rot_zy(model->vertex[0][i], d);
	}
	d += 15;
  }
}


 void create_motion_copter(model3d_t *model){
  int motion, i;
  int d = 60;
  for (motion = 1 ; motion < 6 ; motion ++){
	for (i = 0 ; i < model->vertex_num ; i++){
	  if (i >= 5 && i <= 6){
		model->vertex[motion][i] = rot_xz(model->vertex[0][i], d);
	  }
	  else {
		model->vertex[motion][i] = model->vertex[0][i];
	  }
	}
	d += 60;
  }
}


void create_motion_walker(model3d_t *model){
  int motion, i;
  point3d_t posp = {0, 120, 0};
  point3d_t posm = {0, -120, 0};
  int d = 6;
  for (motion = 1 ; motion < 16 ; motion ++){
      //	printf("motion:%d d:%d\n", motion, d);
	for (i = 0 ; i < model->vertex_num ; i++){
	  if (i >= 8 && i <= 10){
		model->vertex[motion][i]
		  = add_vector3d(rot_xy(add_vector3d(model->vertex[0][i], posp),
								d),
						 posm);
	  }
	  else if (i >= 11 && i <= 13){
		model->vertex[motion][i]
		  = add_vector3d(rot_xy(add_vector3d(model->vertex[0][i], posp),
								-d),
						 posm);
	  }
	  else {
		model->vertex[motion][i] = model->vertex[0][i];
	  }
	}
	if (motion >= 4 && motion <= 11){
	  d -= 6;
	}
	else {
	  d += 6;
	}
  }
  // motion16-310-15180ٲž
  for (motion = 16 ; motion < 32 ; motion ++){
	for (i = 0 ; i < model->vertex_num ; i++){
	  model->vertex[motion][i] = rot_xz(model->vertex[motion-16][i], 180);
	}
  }
}


void create_motion_turret(model3d_t *model){
    int motion, i;
    point3d_t posp = {0, 160, 0};
    point3d_t posm = {0, -160, 0};
    int d = 15;
    for (motion = 1 ; motion < 7 ; motion ++){
        for (i = 0 ; i < model->vertex_num ; i++){
            if (i >= 12 && i <= 15){
                model->vertex[motion][i]
                    = add_vector3d(rot_xy(add_vector3d(model->vertex[0][i],
                                                       posp),
                                          d),
                                   posm);
            }
            else {
                model->vertex[motion][i] = model->vertex[0][i];
            }
        }
        d += 15;
    }
    //    exit(1);
}


void create_motion_fortress(model3d_t *model){
  int motion, i;
  int d = 2;
  for (motion = 1 ; motion < 30 ; motion ++){
      //	printf("motion:%d d:%d\n", motion, d);
	for (i = 0 ; i < model->vertex_num ; i++){
	  model->vertex[motion][i] = rot_xz(model->vertex[0][i], -d);
	}
	d += 2;
  }
}


void create_motion_bomber(model3d_t *model){
    int motion, i;
    int d = 1, da = 1;
    point3d_t posp = {-100,  30, 0};
    point3d_t posm = { 100, -30, 0};

    for (motion = 1 ; motion < 14+3 ; motion ++){
        for (i = 0 ; i < 32 ; i++){
            switch (i) {
            case 16:
            case 17:
            case 18:
            case 19:
                posp.x = -100;
                posm.x =  100;
                model->vertex[motion][i]
                    = add_vector3d(rot_xy(add_vector3d(model->vertex[0][i], 
                                                       posp),
                                          d),
                                   posm);
                break;
            case 20:
            case 21:
            case 22:
            case 23:
                posp.x =  100;
                posm.x = -100;
                model->vertex[motion][i]
                    = add_vector3d(rot_xy(add_vector3d(model->vertex[0][i], 
                                                       posp),
                                          d),
                                   posm);
                break;
            case 24:
            case 25:
            case 26:
            case 27:
                posp.x = -220;
                posm.x =  220;
                model->vertex[motion][i]
                    = add_vector3d(rot_xy(add_vector3d(model->vertex[0][i], 
                                                       posp),
                                          d),
                                   posm);
                break;
            case 28:
            case 29:
            case 30:
            case 31:
                posp.x =  220;
                posm.x = -220;
                model->vertex[motion][i]
                    = add_vector3d(rot_xy(add_vector3d(model->vertex[0][i], 
                                                       posp),
                                          d),
                                   posm);
                break;
            default:
                model->vertex[motion][i] = model->vertex[0][i];          
                break;
            }
        }
        //(+ 1 2 3 4  6 8 10 12   15 18 21 24 27   29)
        if (da < 4){
            da += 1;
        }
        else if (da < 12){
            da += 2;
        }
        else if (da < 27){
            da += 3;
        }
        else if (da < 29){
            da += 2;
        }
        else if (da < 30){
            da += 1;
        }
        d += da;
    }
}

void create_motion_wyvern(model3d_t *model){
    int motion, i;
    int d = 2;

    for (motion = 1 ; motion < 24 ; motion ++){
        //        printf("motion:%d d:%d\n", motion, d*2);
        for (i = 0 ; i < 16 ; i++){
            switch (i) {
            case 6:
                // 
                model->vertex[motion][i]
                    = rot_zy(model->vertex[0][i], d*2);
                break;
            case 7:
            case 8:
            case 9:
                model->vertex[motion][i]
                    = rot_xy(model->vertex[0][i], d*4);
                break;
            case 10:
            case 11:
            case 12:
                model->vertex[motion][i]
                    = rot_xy(model->vertex[0][i], -d*4);
                break;
            default:
                model->vertex[motion][i] = model->vertex[0][i];          
                break;
            }
        }
        if (motion  >= 8 && motion < 16){
            d -= 2;
        }
        else {
            d += 1;
        }
    }
}

void create_motion_byte(model3d_t *model){
    int motion, i;
    int d = 10;
    for (motion = 1 ; motion < 9 ; motion ++){
        //	printf("motion:%d d:%d\n", motion, d);
        for (i = 0 ; i < model->vertex_num ; i++){
            model->vertex[motion][i] = rot_zy(model->vertex[0][i], -d);
        }
        d += 10;
    }
}

void create_motion_gunroid(model3d_t *model){
}


void create_motion_dragon_head(model3d_t *model){
    int motion, i, dir;
    int d =10;

    // motion0-5˺γ˥᡼
    for (motion = 1 ; motion < 6 ; motion ++){
        for (i = 0 ; i < model->vertex_num ; i++){
            switch (i) {
            case 4:
                model->vertex[motion][i] = rot_xy(model->vertex[0][i], -d);
                break;
            default:
                model->vertex[motion][i] = rot_xy(model->vertex[0][i], d);
                //                model->vertex[motion][i] = model->vertex[0][i];
                break;
            }
        }
        d += 10;
    }

    // motion0-5Ƹ˲žƥԡƤ
    for (dir = 1 ; dir <= 4 ; dir ++){
        for (motion = 0 ; motion < 6 ; motion ++){
            for (i = 0 ; i < model->vertex_num ; i++){
                model->vertex[dir * 6 + motion][i]
                    = rot_xz(model->vertex[motion][i], dir*45);
            }
        }
    }
}

void create_motion_dragon(model3d_t *model){
    point3d_t posp, posm;
    //    int d =15;
    int d =1;
    int motion, i;

    for (motion = 1 ; motion < 24 ; motion ++){
        //        printf("motion:%d d:%d\n", motion, d);
        for (i = 0 ; i < model->vertex_num ; i++){
            switch (i) {
            case 15:
                //                printf("tail:%d d:%d %d\n", motion, d, i);
                // 
                model->vertex[motion][i]
                    = rot_xz(model->vertex[0][i], d*2);
                break;
            case 5:
            case 6:
                // 
                posp = reverse_vector3d(model->vertex[0][2]);
                posm = model->vertex[0][2];

                model->vertex[motion][i]
                    = add_vector3d(rot_xz(add_vector3d(model->vertex[0][i],
                                                       posp),
                                          d*2),
                                   posm);
                break;
            case 7:
            case 8:
                // 
                posp = reverse_vector3d(model->vertex[0][3]);
                posm = model->vertex[0][3];

                model->vertex[motion][i]
                    = add_vector3d(rot_xz(add_vector3d(model->vertex[0][i],
                                                       posp),
                                          -d*2),
                                   posm);
                break;
            default:
                model->vertex[motion][i] = model->vertex[0][i];          
                break;
            }
        }
        if (motion  >= 8 && motion < 16){
            d -= 2;
        }
        else {
            d += 1;
        }
    }
/*

    for (motion = 1 ; motion < 24 ; motion ++){
        for (i = 0 ; i < model->vertex_num ; i++){
            model->vertex[motion][i] = rot_xz(model->vertex[0][i], -d);
        }
        d += 30;
    }
*/
}


void create_motion_core(model3d_t *model){
    int d;
    int motion, i;
    //    point3d_t pos;
    point3d_t posp_yaw = {0, 0,-20};
    point3d_t posm_yaw = {0, 0, 20};
    point3d_t posp_mouth = {0, 50,-20};
    point3d_t posm_mouth = {0,-50, 20};
    //    point3d_t posp_roll = {0, 50, 0};
    //    point3d_t posm_roll = {0,-50, 0};
    point3d_t posp_roll_tail = {0, -40, 0};

    // yaw 
    d = 1;
    for (motion = 1 ; motion < 4 ; motion ++){
        for (i = 0 ; i < model->vertex_num ; i++){
            switch (i){
            case 1:                
            case 6:                
                model->vertex[motion][i] 
                    = add_vector3d(rot_xz(add_vector3d(model->vertex[0][i],
                                                       posp_yaw), d*6),
                                   posm_yaw);
                break;
            case 5:                
                model->vertex[motion][i] 
                    = add_vector3d(rot_xz(add_vector3d(model->vertex[0][i],
                                                       posp_yaw), -d*6),
                                   posm_yaw);
                break;
            default:
                model->vertex[motion][i] = model->vertex[0][i];
                break;
            }
            //            model->vertex[motion][i] =  rot_xz(model->vertex[motion][i], 90);
        }
        d++;
    }
    d = 1;
    for (motion = 4 ; motion < 7 ; motion ++){
        for (i = 0 ; i < model->vertex_num ; i++){
            switch (i){
            case 1:                
            case 6:                
                model->vertex[motion][i] 
                    = add_vector3d(rot_xz(add_vector3d(model->vertex[0][i],
                                                       posp_yaw), -d*6),
                                   posm_yaw);
                break;
            case 5:                
                model->vertex[motion][i] 
                    = add_vector3d(rot_xz(add_vector3d(model->vertex[0][i],
                                                       posp_yaw), d*6),
                                   posm_yaw);
                break;
            default:
                model->vertex[motion][i] = model->vertex[0][i];
                break;
            }
            //            model->vertex[motion][i] =  rot_xz(model->vertex[motion][i], 90);
        }
        d++;
    }
    // tail pitch
    d = 1;
    for (motion = 8 ; motion < 12 ; motion ++){
        for (i = 0 ; i < model->vertex_num ; i++){
            switch (i){
            case 5:
                model->vertex[motion][i] 
                    = add_vector3d(rot_zy(add_vector3d(model->vertex[0][i],
                                                       posp_mouth), -d*4),
                                   posm_mouth);
                break;
            default:
                model->vertex[motion][i] = model->vertex[0][i];
                break;
            }
            //            model->vertex[motion][i] =  rot_xz(model->vertex[motion][i], 90);
        }
        d++;
    }
    // open mouth
    d = 1;
    for (motion = 12 ; motion < 20 ; motion ++){
        for (i = 0 ; i < model->vertex_num ; i++){
            switch (i){
            case 1:
                model->vertex[motion][i] 
                    = add_vector3d(rot_zy(add_vector3d(model->vertex[0][i],
                                                       posp_mouth), d*8),
                                   posm_mouth);
                break;
            case 6:
                model->vertex[motion][i] 
                    = add_vector3d(rot_zy(add_vector3d(model->vertex[0][i],
                                                       posp_mouth), -d*8),
                                   posm_mouth);
                break;
            default:
                model->vertex[motion][i] = model->vertex[0][i];
                break;
            }
            //            model->vertex[motion][i] =  rot_xz(model->vertex[motion][i], 90);
        }
        d++;
    }
    // roll on charge
    d = 0;
    for (motion = 20 ; motion < 32 ; motion ++){
        for (i = 0 ; i < model->vertex_num ; i++){
            model->vertex[motion][i] 
                = rot_xz(model->vertex[0][i], d*30);
            if (i == 5){
                model->vertex[motion][i] 
                    = add_vector3d(model->vertex[motion][i], posp_roll_tail);
            }
                /*                
            switch (i){
            case 5:
                model->vertex[motion][i] 
                    = add_vector3d(model->vertex[0][i], posp_roll_tail);
                break;
            default:
                model->vertex[motion][i] 
                    = add_vector3d(rot_xy(add_vector3d(model->vertex[0][i],
                                                       posp_roll), d*30),
                                   posm_roll);
            }
                */
        }
        d++;
    }
}

void create_motion_breath(void){
    int dir, i;

    for (i = 0 ; i < BREATH_LEN ; i++){
        breath[0][i].t.x = -i*20;
        breath[0][i].t.y = -20;
        breath[0][i].t.z = 0;
        breath[0][i].l.x = -i*20;
        breath[0][i].l.y = 0;
        breath[0][i].l.z = 20;
        breath[0][i].r.x = -i*20;
        breath[0][i].r.y = 0;
        breath[0][i].r.z = -20;
        breath[0][i].b.x = -i*20;
        breath[0][i].b.y = 20;
        breath[0][i].b.z = 0;
    }
    for (dir = 1 ; dir < 5 ; dir ++){
        for (i = 0 ; i < BREATH_LEN ; i++){
            breath[dir][i].t = rot_xz(breath[0][i].t, dir*45);
            breath[dir][i].l = rot_xz(breath[0][i].l, dir*45);
            breath[dir][i].r = rot_xz(breath[0][i].r, dir*45);
            breath[dir][i].b = rot_xz(breath[0][i].b, dir*45);
        }
    }
}

